#!/usr/bin/python3
import os
import sys

# Global variables

# Now, it is better to use global variables in this jobscript maker.
g_exampleVariable = "Global Example Variable" 

def showUsageInformation():
	print()
	print("Majops Skeleton Script Jobscript Maker Python3 makes the jobscripts")
	print("for the minor pipeline for processing and analyzing its own data set.")
	print("The user has to type here what jobscript maker can perform and does.")
	print("")
	print("Way of usage:")
	print("")
	print("The user has to type here how he has to work with")
	print("jobscript maker script and how the command line arguments")
	print("are used.")
	print("")
	print("Example:")
	print("")
	print("python3 MajopsSkeletonScriptJobscriptMakerPython3.py input1.txt \\")
	print("			input2.csv 10 output.csv")
	print("")
	
	sys.exit()

# For each minor highway bash script and for each minor submission bash script, 
# the header lines for its jobscript is generated here.
# A list of strings is generated that will be returned.
def getHeadersJobscript():
		
	lstHeaderLines = []	
	
	lstHeaderLines.append("#!/bin/bash " + "\n")
	lstHeaderLines.append("...\n")
	
	
	return lstHeaderLines

# A new jobscript is made here for each new minor pipeline.
def makeNewJobscript():
	# A new jobscript is made from scratch.
	# N.B.: Every time a new jobscript is made, change its name.
	jobscriptFileName="Example_Jobscript.sh"  
	
	outputJobscriptFile = open(jobscriptFileName, "w")
	
	# Make the header texts.
	outputJobscriptFile.writelines(getHeadersJobscript())
	
	outputJobscriptFile.close()
	
	# The jobscript is opened again, but now the mode is on appending.
	# From here, the real minor pipeline is being built. 
	outputJobscriptFile = open(jobscriptFileName, "a")	
	
	# First, all the lines of code that will be created here for the minor pipeline
	# have to be saved for a while in a list.
	# At the end, when all the code has been generated, all those lines can be
	# written at once to the jobscript file.
	# That way of making a minor pipeline is the fastest way to do it. 
		
	lstAllLinesMinorPipelineExample = []
	
	# All the lines of code for the minor pipeline are programmed here
	# and appended to the list. 
	
	# The whole minor pipeline is now saved at once to the jobscript file. 	
	outputJobscriptFile.writelines(lstAllLinesMinorPipelineExample)
	
	# If it is necessary, some ending lines for the minor pipelines
	# can be programmed here and saved to the jobscript file. 
	
	outputJobscriptFile.close()

# From here till the main function, other functions have to be programmed. 
# An example function: showHelloWorld
def showHelloWorld(helloWorld):
	global g_exampleVariable
	
	print("")
	print(helloWorld)
	print("")
	print(g_exampleVariable)
	print("")
        
# The last function is always the main function, in which only other functions are called.
def main(argv):
	if len(argv) >= 2:
		if argv[1] == "-h" or argv[1] == "--h" or argv[1] == "-help" or argv[1] == "--help":
			showUsageInformation()
			
	helloToUser = "Hello World!"
	
	showHelloWorld(helloToUser) # Example of a function.
	
	makeNewJobscript()
                               
if __name__ == "__main__":
	main(sys.argv)
	
# Additional information:
# =======================
#
# Remarks about the Majops Skeleton Script Jobscript Maker Python3 itself.
# Description how it works.
# Description which improvements can be done to improve the Majops Skeleton Script Jobscript Maker Python3 itself.
#
