#!/usr/bin/perl
use strict;
use warnings;

# Global variables

my $g_exampleVariable = "Global Example Variable";  # Only, if this is necessary

sub showUsageInformation {
	print "\n"; 
	print "Majops Skeleton Script Perl is the base for making new scripts in Perl. \n";
	print "The user has to type here what the Perl script can perform and does. \n";
	print "\n";
	print "Way of usage: \n";
	print "\n";
	print "The user has to type here how he has to work with the Perl script and \n";
	print "how the command line arguments are used. \n";
	print "\n";
	print "Example: \n";
	print "\n";
	print "perl MajopsSkeletonScriptPerl.pl input1.txt input2.csv 10 output.csv \n";
	print "\n";
	
	exit;
}

# From here till the main subroutine, subroutines have to be programmed. 
# An example subroutine: showHelloWorld
sub showHelloWorld {
	
	my $helloworld = $_[0];
	
	print "\n";
	print "$helloworld\n";
	print "\n";
	print "$g_exampleVariable\n";
	print "\n";
}
        
# The last subroutine is always the main subroutine, in which only other subroutines are called.
sub main {
	my $numArgs = scalar @_;
	if ($numArgs >= 1) {
		if ($_[0] eq "-h" or $_[0] eq "--h" or $_[0] eq "-help" or $_[0] eq "--help") {
			showUsageInformation();
		}
	}
			
	my $helloToUser = "Hello World!";
	
	showHelloWorld($helloToUser); # Example of a function.
}
                               
main(@ARGV);

# Additional information:
# =======================
#
# Remarks about the Majops Skeleton Script Perl itself.
# Description how it works.
# Description which improvements can be done to improve the Majops Skeleton Script Perl itself.
#
